/*
 * The Fifteen
 * by Ritchie - http://ritchie.jikos.cz  email:ritchie@jikos.cz
 *
 */

//Some constants and variables
var freePos = freePosition;  //current free position
var positions = new Array;   //an internal array of positions
var paintAllowed = false;    //if any output is allowed
var completed = false;       //if the puzzle is completed


//Initialization. Making number array or replacing transparent image.
if(type == "numbers") {
  var numbers = new Array;
  for(i=1;i<=cols*rows;i++)
    numbers[i] = i;
  numbers[freePos] = "&nbsp;";
}
else if(type == "images")
  imagesTransparent();


//Adding handle to event under Netscape 4 as method onmousedown under IE.
//!!EXPERIMENTAL!!
if(document.layers && type=="images") {
  document.captureEvents(Event.MOUSEDOWN);
  document.onmousedown=handle;
}

//This function enables calling move() under Netscape 4.
function handle(event){
  id = event.target.name;
  if(id.indexOf(prefix) == 0)
    move(id);
}


//It swaps the transparent and the free-positioned image.
function imagesTransparent() {
  temp = image.images[0];
  image.images[0] = image.images[freePos];
  image.images[freePos] = temp;
}


//It swaps two positions in the internal positions array.
function swap(a,b) {
  temp = positions[a];
  positions[a] = positions[b];
  positions[b] = temp;
  if(paintAllowed) {
    paint(a,b);  //repaint according current internal positions array
    score();     //count score
  }
}


//They call swap with propriet parameters to move in a direction.

function moveLeft() {
  if((freePos-1) % cols != 0)
    swap(freePos,freePos-=1);

}

function moveRight() {
  if(freePos % cols != 0)
    swap(freePos,freePos+=1);
}

function moveUp() {
  if((freePos-cols)>0)
    swap(freePos,freePos-=cols);
}

function moveDown() {
  if((freePos+cols)<=(cols*rows))
    swap(freePos,freePos+=cols);
}


//It decides which direction to move.
//This is compute with an id number and the free position and with some mathematics.
function move(id) {
  if(!completed) {
    index = parseInt(id.substr(id.lastIndexOf("-")+1));
    if(freePos-index == 1)
      moveLeft();
    if(freePos-index == -1)
      moveRight();
    if(freePos-index == cols)
      moveUp();
    if(freePos-index == -cols)
      moveDown();
  }
}

//It repaints given field or whole table.
function paint() {
  if(type == "numbers") {      //numbers
    if(arguments[0]) {         //only given list of fields
      for(i=0;arguments[i];i++) {
        cell = document.getElementById(prefix+"-"+arguments[i]);
	cell.innerHTML = numbers[positions[arguments[i]]];
      }
    }
    else {                     //all fields
      for(i=1;i<=rows*cols;i++) {
	cell = document.getElementById(prefix+"-"+i);
	cell.innerHTML = numbers[positions[i]];
      }
    }
  }
  else if(type == "images") {  //images
    if(arguments[0]) {         //only given list of fields
      for(i=0;arguments[i];i++) 
	document.images[prefix+"Img-"+arguments[i]].src = image.path+image.images[positions[arguments[i]]];
    }
    else {                     //all fields
      for(i=1;i<=rows*cols;i++)
	document.images[prefix+"Img-"+i].src = image.path+image.images[positions[i]];
    }
  }
}


//It randomize the array.
function initialize() {
  completed = false;
  freePos = freePosition;
  for(i=1;i<=cols*rows;i++)    //reset of the internal positions array
    positions[i] = i;
  paintAllowed = false;
  for(i=0;i<randomize;i++) {   //randomization
    rnd = Math.floor(Math.random()*4);
    switch(rnd) {
    case 0: moveLeft();moveLeft();moveUp();moveRight();break;
    case 1: moveRight();moveRight();moveDown();moveLeft();break;
    case 2: moveUp();moveUp();moveRight();moveDown();break;
    case 3: moveDown();moveDown();moveLeft();moveUp();break;
    }
  }
  moves = 0;
  paintAllowed = true;
}


//It builds a board (a lot of documnent.writeln ...).
function buildBoard() {
  document.writeln('<table class="fifteen" border="0" cellpadding="0" cellspacing="0">');
  for(m=0;m<rows;m++) {
    document.write("<tr>");
    for(n=1;n<=cols;n++) {
      pos = m*cols+n;
      if(type=="numbers") {
	document.write('<td id="'+prefix+'-'+pos+'" class="number" onmousedown="move(this.id)">');
	document.write(numbers[positions[pos]]);
      }
      else if(type=="images") {
	document.write('<td id="'+prefix+'-'+pos+'" onmousedown="move(this.id)">');
        document.write('<img src="'+image.path+image.images[positions[pos]]+'" id="'+prefix+'Img-'+pos+'" width="'+image.width+'" name="'+prefix+'Img-'+pos+'"height="'+image.height+'" vspace="0" hspace="0" alt="" />');
      }
      document.write('</td>');
    }
    document.writeln('</tr>');
  }
  document.writeln('</table>');

  if(type == "images") {
    var preCache = new Image;
    preCache.src = image.path+image.images[0];
  }

}

function buildControl()  {
  document.writeln('<form id="control" name="control">');
  document.writeln('<table style="width: 320px;" width="320" border=0 align="right">');
  document.writeln('<tr>');
  document.writeln('<td><input type="button" id="newgame" name="newgame" value="NOV HRA" onclick="restart();" /></td>');
  document.writeln('<td>Body: <input type="text" id="moves" name="moves" value="0" style="width: 4ex; text-align: right;" width="3" text-align="right" readonly="readonly"/></td>');
  document.writeln('</tr>');
  document.writeln('</table>');
  document.writeln('</form>');
}


//It updates (write) score.
function updateScore() {
  if(paintAllowed)
    document.forms.control.elements.moves.value = moves;
}


//It checks whether the game is finished and counts moves/score.
function score() {
  moves++;
  updateScore();
  completed = true;
  for(i=rows*cols-1;i>0;i--)   //check if the game is finished
    if(positions[i]!=i) {
      completed = false;
      break;
    }

  if(completed) {              //show the propriet number/image instead of transparent
    if(type == "numbers") {
      numbers[freePos] = freePos;
      paint(freePos);
      numbers[freePos] = "&nbsp;";
    }
      else if(type == "images") {
      imagesTransparent();
      paint(freePos);
      imagesTransparent();
    }
  }
}


//Set of functions to restart game.
function restart() {
  initialize();
  paint();
  updateScore();
}


/* * * * * * */
initialize();
